void setupLEDs() {
  for (int i = 0; i < 3; i++) {       // set all LED pins as outputs
    for (int j = 0; j < 2; j++) {
      pinMode(ledPin[i][j], OUTPUT);
    }
  }
}



////////////////////////////////////////////////////////////////////////////////////////////////

void fadeLEDs(int channel, int ledTime, int r1, int g1, int b1, int r2, int g2, int b2) { // fade 'channel' from r1g1b1 to r2g2b2 in ledTime ms
  rBegin[channel] = r1;                 // beginning RGB values
  gBegin[channel] = g1;
  bBegin[channel] = b1;
  rEnd[channel] = r2;                   // final RGB values
  gEnd[channel] = g2;
  bEnd[channel] = b2;
  LEDbegin[channel] = millis();         // time when RGB LED fade started
  LEDend[channel] = millis() + ledTime; // time when RGB LED fade will finish
}

////////////////////////////////////////////////////////////////////////////////////////////////

void updateLEDs() {                     // updates all LED outputs (switches the actual outputs)


  for (int channel = 0; channel < 2; channel++) {                     // cycle through three output channels
    unsigned long LEDnow = millis() - LEDbegin[channel];              // now (within duration)
    unsigned long LEDduration = LEDend[channel] - LEDbegin[channel];  // duration of fade in ms
    if (LEDduration == 0) {                                           // make sure duration is not 0...
      LEDduration = 1;                                                // ... in order to avoid division by zero
    }
    float f = 100;
    f = f / float(LEDduration);                                       // f is a stretching/compressing factor in order to give the whole duration 100% time
    float percent = float(LEDnow) * f;                                // calculate at which percent of the fade we are currently
    percent = constrain(percent, 0.001, 100.0);                       // constrain percentage in order to avoid extrapolation

    int rNow = map(int(percent), 0, 100, rBegin[channel], rEnd[channel]); // calculate current rgb values
    int gNow = map(int(percent), 0, 100, gBegin[channel], gEnd[channel]);
    int bNow = map(int(percent), 0, 100, bBegin[channel], bEnd[channel]);

    rNow = gamma[rNow];
    gNow = gamma[gNow];
    bNow = gamma[bNow];


    analogWrite(ledPin[channel][0], gNow);                               // apply rgb values to pwm outputs
    analogWrite(ledPin[channel][1], rNow);
    analogWrite(ledPin[channel][2], bNow);

    if (stormDetected) {
      analogWrite(ledPin[channel][0], 0);                               // apply rgb values to pwm outputs
      analogWrite(ledPin[channel][1], 255 * ((millis() / 500) % 2));
      analogWrite(ledPin[channel][2], 0);
    }



  }
}
////////////////////////////////////////////////////////////////////////////////////////////////
void setK4LEDs(boolean rK4, boolean gK4, boolean bK4) {

}


