

//-------------------------------------------------------------------- reads anemometer and returns RPM
float readAnemometer(){
  int anemometerSensor = analogRead(A2); // reads the value from lightbarrier inside anemometer
  if (anemometerSensor > 600) {                                             // checks for HI with hysteresis
    anemometerState = HIGH;                                               // set state to HI
  }
  if (anemometerSensor < 500) { // checks for LO with hysteresis
    if (anemometerState == HIGH) { // checks for HI->LO flange
      unsigned long anemometerDuration = millis() - anemometerTime;       // how many millis did the rotation take?
      anemometerTime = millis();                                          // remember moment of flange
      anemometerRPM = 60000.0 / anemometerDuration;                       // calculate RPM
      //Serial.print("ANEMOMETER...........................RPM:");
      //Serial.println(anemometerRPM);
    }
    anemometerState = LOW;                                                // set state to LO
  }
  if ((anemometerTime + 10000L) < millis() && anemometerRPM>.01) {        // check if RPM is below 6 (more than 10 seconds since last flange)
    anemometerRPM = 0;
    //Serial.print("RESET ANEMOMETER RPM:........................................RPM:");
    //Serial.println(anemometerRPM);
  }

  return (anemometerRPM);
}
