
void setupKeybd() {
  for (int i = 32; i < 50; i++) { // Keyboard input pins 32-49
    pinMode(i, INPUT_PULLUP);
  }
}

// function reads keyboard and updates 'key[]'-array. also checks sliding and updates 'instrument'

boolean readKeyboard() {
  //read keyboard (in strange order because of the connector)

  int scanCount = 0;
  for (int scanOctave = 0; scanOctave < 4; scanOctave++) {  // scanning through four octaves
    // reset all octave pins
    for (int i = 0; i < 4; i++) {
      pinMode(octavePins[i], INPUT);                        // reset all octave pins
    }
    pinMode(octavePins[scanOctave], OUTPUT);                // activate octave pin based on scan
    digitalWrite(octavePins[scanOctave], LOW);
    delay(1);

    
    for (int scanKey = 0; scanKey < 12; scanKey++) {        // cycle through all key inputs and get key presses
      key[scanCount] = (!digitalRead(keyPins[scanKey]));
      if (scanCount == 36) {
        scanKey = 12;
      }
      scanCount++;
    }
  }

  boolean keyUsed = false;
  for (int i = 0; i < MAX_INPUT_KEYS; i++) { //check if any key was pushed or released
    if (key[i] != pKey[i]) {
      keyUsed = true;            // set return value
      pKey[i] = key[i];          // remember key state for future comparison
      if (key[i]) {              // SLIDE DETECTION: if key was pushed:

        if (i > lastKey) {       // if key is higher than the key that was pushed before:
          if (keybdSlide >= 0) { // if slide value is not negative
            keybdSlide++;        // increment slide value
          } else {
            keybdSlide = 0;      // if slide value was negative: reset it
          }
        }
        if (i < lastKey) {       // if key is lower than key that was pushed before:
          if (keybdSlide <= 0) { // if slide value is not positive
            keybdSlide--;        // decrement alide value
          } else {
            keybdSlide = 0;      // if slide value was positive: reset it
          }
        }
        lastKey = i;              // remember last key that was pushed for SLIDE DETECTION in next loop
      }
    }

  }
  if (keybdSlide == 8) {          // slide upwards detected:
    instrument++;                 // increment instrument value
    keybdSlide = 0;               // reset slide value
  }
  if (keybdSlide == -8) {         // slide downwards detected
    instrument--;                 // decrement instrument value
    keybdSlide = 0;               // reset slide value
  }
  if (instrument == -1)instrument = 3; // diy modulo function: keep instrument value between 0 & 3 (inclusive)
  if (instrument == 4)instrument = 0;

  return keyUsed;                 // return true if keyboard was used (key pressed or released)
}

