//---------------------------------- LOGGING

void saveSD(String sdData) {
  if (sdData != "" ) {            // check if there's something to write on SD card
    boolean newFile = false;      // remembers if a new file has been created
    rtc.update();                   // updates rtc.seconds(), rtc.minutes(), ...
    fileTime = rtc.minute() / 10; // check time
    if (fileTime != pFileTime) {  // has a new ten minutes time frame started?
      pFileTime = fileTime;       // remember time
      fileNumber++;               // increase file number
      newFile = true;             // remember that a new file has been created
    }

    currentLogFile = SD.open(createFilename(fileNumber), FILE_WRITE);// open file
    if (newFile) {                // is this a new file?
      //............................ assemble file header
      String header = String(rtc.date()) + "." + String(rtc.month()) + "." + String(rtc.year()) + "  " + String(rtc.hour()) + ":" + String(rtc.minute()) + ":" + String(rtc.second()) + "\n";
      header += "Key[] , On/Off, Instrument (0...9), Milliseconds, \n";
      header += " 0 , OFF , 0 , ";
      header += String(millis() - 1000L);
      header += "\n";
      header += " 0 , OFF , 0 , ";
      header += String(millis() - 500L);
      header += "\n";

      if (currentLogFile) {               // if the file is available, write header
        currentLogFile.print(header);
        Serial.println("---------------------------------------");
        Serial.print("Start new file: '");
        Serial.print(createFilename(fileNumber));
        Serial.println("'");
        Serial.print(header);
      }
    }
    if (currentLogFile) {                 // if the file is available, append data
      currentLogFile.print(sdData);
      Serial.print("save: ");
      Serial.print(sdData);
      currentLogFile.close();
    } else {                      // if the file isn't open, pop up an error:
      Serial.println("error opening logfile");
    }
  }
}


//.............................. create filename & path
String createFilename(int number) {
  String logFileName = "keybdlog/log";
  for (int i = 5 - String(number).length(); i > 0; i--) {
    logFileName += "0";
  }
  logFileName += String(number);
  logFileName += ".CSV";
  return logFileName;
}


