//------------------------------------------------------------------------ SD card functions
void setupSD() {
  const int chipSelect = 53;
  Serial.print("initializing SD card...");

  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("card failed, or not present");
    // don't do anything more:
    return;
  }
  Serial.println("card initialized - count files:");
  SD.mkdir("/keybdlog");
  fileNumber = countFilesSD();
  Serial.println("files on SD card: " + String(fileNumber));
  rtc.update();                       // updates rtc.seconds(), rtc.minutes(), ...
  fileTime = rtc.minute() / 10;       // remember when file was created (min/10)
  pFileTime = fileTime - 1;           // make sure times are different so that fileheader will be written
}

//------------------------------------------------------------------------ count amount of logfiles on SD card

int countFilesSD() { //counts amount of logfiles in /KEYBDLOG directory
  int fileCount = 0;
  File dir = SD.open("/KEYBDLOG");
  while (true) {

    wdt_reset();     // reset watchdog timer
    File entry =  dir.openNextFile();
    if (! entry) {
      break;
    }
    if (!entry.isDirectory()) {
      fileCount++;
    }
    entry.close();
  }
  return fileCount;
}

