

void pushKeyToSynth() {
  for (int i = 0; i < MAX_INPUT_KEYS; i++) {    // copy key[]-array to synth[]-array
    synth[i] = key[i];
  }
}


String playSynth() {              // play synth based on changes in synth[] array
  String logString = "";          // make a string for assembling the data to log:
  for (int i = 0; i < MAX_INPUT_KEYS; i++) {  // cycle through synth array (each synth[n] stands for one note as an input)
    if (synth[i] && !pSynth[i]) { // if note started:

      midiSetInstrument(0, instruments[instrument]); //(bank#, instrument#)
      if (nightMode) {
        midiNoteOn(0, i + 48, 80); // play note with night volume
      } else {
        midiNoteOn(0, i + 48, 127); // play note with day volume
      }
      if (i < 10) {               // write in log string (key, on, instrument, millis)
        logString += " ";
      }
      logString += String(i);
      logString += " , ON  , ";
      logString += String(instrument);
      logString += " , ";
      logString += String(millis());
      logString += "\n";
    }
    if (!synth[i] && pSynth[i]) { // if note was released:
      midiNoteOff(0, i + 60, 127);// release note
      if (i < 10) {               // write in log string (key, off, instrument, millis)
        logString += " ";
      }
      logString += String(i);
      logString += " , OFF , ";
      logString += String(instrument);
      logString += " , ";
      logString += String(millis());
      logString += "\n";
    }
    pSynth[i] = synth[i];             // save synth state for next cycle
  }
  return logString;
}
